// Generated by CoffeeScript 1.10.0
var async, change, fs, gutil, http, jsfy, mime, path, stylus, through2,
  slice = [].slice;

fs = require('fs');

path = require('path');

http = require('http');

through2 = require('through2');

async = require('async');

change = require('change-case');

mime = require('mime');

stylus = require('stylus');

gutil = require('gulp-util');

jsfy = function(options) {
  if (options == null) {
    options = {};
  }
  return through2.obj(function(file, encode, next) {
    if (file.isStream()) {
      return this.emit('error', new gutil.PluginError('gulp-jsfy', 'Streaming not supported'));
    }
    if (file.path.substr(-4) !== '.css') {
      this.push(file);
      return next();
    }
    return jsfy.parse(file, options, (function(_this) {
      return function(error, js) {
        if (error != null) {
          return _this.emit('error', new gutil.PluginError('gulp-jsfy', error));
        }
        file.path += '.js';
        file.contents = new Buffer(js);
        _this.push(file);
        return next();
      };
    })(this));
  });
};

jsfy.parse = function() {
  var args, callback, deval, file, options;
  file = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
  callback = void 0;
  options = {};
  args.forEach(function(arg) {
    switch (typeof arg) {
      case 'function':
        return callback = arg;
      case 'object':
        return options = arg;
    }
  });
  deval = function(error, file) {
    var name;
    if (error != null) {
      return callback(error);
    }
    name = path.basename(file.path, '.css');
    if (options.dataurl) {
      return jsfy.replaceToDataURI(file, options, function(error, css) {
        if (error != null) {
          return callback(error);
        }
        file.contents = new Buffer(css);
        return callback(null, jsfy.deval(file, name, options));
      });
    } else {
      return callback(null, jsfy.deval(file, name, options));
    }
  };
  if (options.wrapInClass) {
    return jsfy.wrap(file, options, function(error, css) {
      if (error != null) {
        return deval(error);
      }
      file.contents = new Buffer(css);
      return deval(null, file, null, options);
    });
  } else {
    return deval(null, file, null, options);
  }
};

jsfy.deval = function() {
  var args, charset, css, name, options;
  css = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
  name = void 0;
  charset = 'utf8';
  options = {};
  args.forEach(function(arg) {
    switch (typeof arg) {
      case 'string':
        return name = arg;
      case 'object':
        return options = arg;
    }
  });
  if (options.charset === false) {
    charset = '';
  }
  return ";(function(){\n  var link=document.createElement('link');\n  link.setAttribute('data-name','" + (change.snakeCase(name)) + "');\n  link.setAttribute('rel','stylesheet');\n  link.setAttribute('href',\"" + (jsfy.dataurify(css, 'text/css', charset)) + "\");\n  document.head.appendChild(link);\n})();";
};

jsfy.dataurify = function(str, type, charset) {
  var data;
  if (charset == null) {
    charset = '';
  }
  data = typeof str === 'object' ? str.contents : new Buffer(str);
  if (charset.length > 0 && charset.indexOf(';') !== 0) {
    charset = ";charset=" + charset;
  }
  return "data:" + type + charset + ";base64," + (data.toString('base64'));
};

jsfy.cssfy = function(devalJs) {
  var begin, dataurl, end;
  begin = devalJs.indexOf('data:text/css;');
  end = devalJs.indexOf('"', begin) - begin;
  dataurl = (new Buffer(devalJs.substr(begin, end), 'base64')).toString('utf8');
  return (new Buffer(devalJs.substr(begin, end).split(',')[1], 'base64')).toString();
};

jsfy.replaceLocalPattern = /url\((?!(["']?(data|http))).+?\)/g;

jsfy.replaceGlobalPattern = /url\((?!(["']?(data))).+?\)/g;

jsfy.replaceToDataURI = function() {
  var args, callback, file, matches, options, pattern, str;
  file = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
  callback = void 0;
  pattern = void 0;
  options = {};
  args.forEach(function(arg) {
    switch (typeof arg) {
      case 'function':
        return callback = arg;
      case 'string':
        return pattern = arg;
      case 'object':
        return options = arg;
    }
  });
  if (pattern === void 0) {
    pattern = options.ignoreURL ? jsfy.replaceLocalPattern : jsfy.replaceGlobalPattern;
  }
  str = file.contents.toString();
  matches = str.match(pattern) || [];
  return async.map(matches, function(match, next) {
    var begin, end, is_local, qs, ref, schema;
    begin = match.indexOf('(') + 1;
    end = match.length - begin - 1;
    schema = match.substr(begin, end).replace(/"|'/g, '');
    is_local = schema.indexOf('http') !== 0;
    if (is_local) {
      schema = path.resolve(path.dirname(file.path), schema);
    }
    if (is_local) {
      ref = schema.split(/[\?#]/), schema = ref[0], qs = ref[1];
      return jsfy.readDataURI(schema, function(error, datauri) {
        str = str.replace(match, "url(" + datauri + ")");
        return next(error);
      });
    } else {
      return jsfy.fetchDataURI(schema, function(error, datauri) {
        str = str.replace(match, "url(" + datauri + ")");
        return next(error);
      });
    }
  }, function(error) {
    return callback(error, str);
  });
};

jsfy.readDataURI = function(filename, callback) {
  return fs.readFile(filename, function(error, buffer) {
    var data, type;
    if (error === null) {
      type = mime.lookup(filename);
      data = buffer.toString('base64');
      return callback(null, "data:" + type + ";base64," + data);
    } else {
      return callback(error);
    }
  });
};

jsfy.fetchDataURI = function(url, callback) {
  return http.get(url, function(response) {
    var chunks;
    chunks = '';
    response.on('data', function(buffer) {
      return chunks += buffer.toString();
    });
    return response.on('end', function() {
      var ref, type;
      type = response != null ? (ref = response.headers) != null ? ref['content-type'] : void 0 : void 0;
      return callback(null, "data:" + type + ";base64," + ((new Buffer(chunks)).toString('base64')));
    });
  }).on('error', function(error) {
    return callback(error);
  });
};

jsfy.wrap = function() {
  var args, callback, className, css, file, options;
  file = arguments[0], args = 2 <= arguments.length ? slice.call(arguments, 1) : [];
  callback = void 0;
  className = void 0;
  options = {};
  args.forEach(function(arg) {
    switch (typeof arg) {
      case 'function':
        return callback = arg;
      case 'string':
        return className = arg;
      case 'object':
        return options = arg;
    }
  });
  css = file.contents.toString();
  className = change.snakeCase(path.basename(file.path, '.css'));
  return stylus.render("." + className + "{ " + css + " }", function(error, css) {
    return callback(error, css);
  });
};

module.exports = jsfy;
